#import <ObjFW/ObjFW.h>
#import <ObjXMPP/ObjXMPP.h>

#import "JubGtkUI.h"

@interface AppDelegate: OFObject
    <OFApplicationDelegate, XMPPConnectionDelegate, XMPPRosterDelegate>
{
	XMPPConnection *connection;
	XMPPRoster *roster;
	id<JubUI> ui;
}
@end

OF_APPLICATION_DELEGATE(AppDelegate)

@implementation AppDelegate
- (void)applicationDidFinishLaunching
{
	id<XMPPRosterDelegate, XMPPConnectionDelegate> rosterDelegate;

	connection = [[XMPPConnection alloc] init];
	[connection addDelegate: self];

	connection.domain = @"localhost";
	connection.username = @"alice";
	connection.password = @"test";

	ui = [[JubGtkUI alloc] initWithConnection: connection];
	rosterDelegate = [ui rosterDelegate];

	[connection addDelegate: rosterDelegate];

	roster = [[XMPPRoster alloc] initWithConnection: connection];
	[roster addDelegate: rosterDelegate];
	[roster addDelegate: self];

	[connection asyncConnectAndHandle];

	[ui startUIThread];
}

- (void)connection: (XMPPConnection*)conn_
     wasBoundToJID: (XMPPJID*)jid
{
	of_log(@"Bound to JID: %@", [jid fullJID]);

	[roster requestRoster];
}

- (void)rosterWasReceived: (XMPPRoster*)roster
{
	[connection sendStanza: [XMPPPresence presence]];
}

-  (void)connection: (XMPPConnection*)conn
  didReceiveElement: (OFXMLElement*)element
{
	of_log(@"In:  %@", element);
}

- (void)connection: (XMPPConnection*)conn
    didSendElement: (OFXMLElement*)element
{
	of_log(@"Out: %@", element);
}
@end
